<?php
namespace Claromentis\Stat\Telemetry;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"] = (@$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] ?: array()) + array("_19ab1d3c28df6292f3" . "bb65e6e28bcf6b" => base64_decode("Q29ud" . "GVudC" . "1UeXB" . "l"), "_3d48252951c547cdd2" . "621ae058c548bf" => base64_decode("U0VMRUNUICogRlJPTSB0ZWxlbWV0cnlfcGF5bG9hZHMgV0hFUkUgaXN" . "fc2VudCA9IDAgT1JERVIgQlkgY3JlYXRlZCBBU0M="), "_ab2030555cfbe63c67a304c58" . "283a0a6" => base64_decode("aHR0cF9idWlsZF9xdWVyeQ" . "=="), "_8103cde0d9ad96f74c0f" . "dbaeb4d19384" => base64_decode("VVBEQVRFIHRlbGVtZXRyeV9w" . "YXlsb2FkcyBTRVQgaXNfc2Vu" . "dCA9IDEgV0hFUkUgaWQgPSBp" . "bnQ6cGF5bG9hZF9pZA=="), "_56663503889" . "58f9be4caf8f" . "9057f6ab6" => base64_decode("YXBwbGljYXRpb24veC13d3ctZm" . "9ybS11cmxlbmNvZGVk"), "_513c03e0d7cc51917a50cb99" . "eb3d3cbc" => base64_decode("ZGF0YWJhc2UgaW5zZXJ" . "0IGZhaWxlZA=="), "_8ec8f26c742278f906" . "15f50d682eea79" => base64_decode("UE9" . "TVA" . "=="), "_1b03be40" . "52296e3a9" . "08b79bc90" . "d42761" => base64_decode("SU5TRVJUIElOVE8gdGVsZW1ldHJ5X3BheWxvYWRzIChjcmVhdGVkLCBwYXlsb2FkLCBpc19zZW50KSBWQUxVRVMgKGludDp0aW1lc3RhbXAsIGNsb2I6cGF5bG" . "9hZCwgaW50OnNlbnQp"), "i" . "d" => base64_decode("a" . "W" . "Q" . "="), "_f4bd77b9" . "d7574792b" . "d46db7358" . "6ce19d" => base64_decode("cGF5bG" . "9hZA=="));
use Claromentis\Core\DAL\Db;
use Claromentis\Core\DAL\Query;
use Exception;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Psr7\Request;
class PayloadDispatch
{
    
    
    private $host;
    
    
    
    
    
    private $db;
    
    
    public $timeout = 3;
    
    
    public $max_unsent_payloads = 3;
    
    
    public $response_code;
    public function __construct($_99aecd7d25aa990307d2decfc5ef9490, $db)
    {
        $this->host = $_99aecd7d25aa990307d2decfc5ef9490;
        $this->db = $db;
    }
    public function Save($_f4bd77b9d7574792bd46db73586ce19d, $_97ea09a7faf27c52c6eff69773df1d8a, $_e53057a61b22b5c32ec963080a36d30b = false)
    {
        
        
        $this->db->DisableTokenCheck();
        $query = new Query($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_1b03be4052296e3a908b79bc90" . "d42761"], $_97ea09a7faf27c52c6eff69773df1d8a, $_f4bd77b9d7574792bd46db73586ce19d, $_e53057a61b22b5c32ec963080a36d30b);
        $result = $this->db->query($query);
        $this->db->EnableTokenCheck();
        if (!$result) {
            throw new Exception($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_513c03e0d7c" . "c51917a50cb9" . "9eb3d3cbc"]);
        }
    }
    public function DispatchAndSave($_f4bd77b9d7574792bd46db73586ce19d, $_97ea09a7faf27c52c6eff69773df1d8a)
    {
        $_e53057a61b22b5c32ec963080a36d30b = $this->Dispatch($_f4bd77b9d7574792bd46db73586ce19d, true);
        $this->Save($_f4bd77b9d7574792bd46db73586ce19d, $_97ea09a7faf27c52c6eff69773df1d8a, $_e53057a61b22b5c32ec963080a36d30b);
        if ($_e53057a61b22b5c32ec963080a36d30b) {
            
            
            $this->DispatchUnsentPayloads();
        }
        return $_e53057a61b22b5c32ec963080a36d30b;
    }
    public function Dispatch($_f4bd77b9d7574792bd46db73586ce19d, $_436f271e28c93a307e4ef91248c1ac13 = false)
    {
        $client = new Client([]);
        $_f50e845669e7cd06bbc643eeb57aa01d = [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_f4bd77b9d7574792bd46db" . "73586ce19d"] => $_f4bd77b9d7574792bd46db73586ce19d];
        $_1cc5aa2f679b575f82786a73f0da28f8 = \GuzzleHttp\Psr7\stream_for($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_ab2030555cf" . "be63c67a304c" . "58283a0a6"]($_f50e845669e7cd06bbc643eeb57aa01d));
        $request = new Request($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_8ec8f26c742278f90615f50d6" . "82eea79"], $this->host, [$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_19ab1d3c28" . "df6292f3bb6" . "5e6e28bcf6b"] => $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_5666350388958f9b" . "e4caf8f9057f6ab6"]], $_1cc5aa2f679b575f82786a73f0da28f8);
        try {
            $response = $client->send($request);
        } catch (GuzzleException $e) {
            
            
            return 0;
        }
        $_7ea20fadecb13c1b305ef4041ff32e51 = $response->getStatusCode();
        if ($_436f271e28c93a307e4ef91248c1ac13) {
            
            
            $this->response_code = $_7ea20fadecb13c1b305ef4041ff32e51;
        }
        if ($_7ea20fadecb13c1b305ef4041ff32e51 != 200) {
            
            
            return 0;
        }
        return 1;
    }
    public function DispatchUnsentPayloads()
    {
        
        
        $query = new Query($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_3d48252951c547cdd2621ae058c548" . "bf"]);
        $query->setLimit($this->max_unsent_payloads);
        $result = $this->db->query($query);
        while ($row = $result->fetchArray()) {
            if ($this->Dispatch($row[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_f4bd77b" . "9d757479" . "2bd46db7" . "3586ce19" . "d"]])) {
                $this->MarkPayloadSent($row[$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["i" . "d"]]);
            }
        }
    }
    private function MarkPayloadSent($id)
    {
        $query = new Query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_8103cde" . "0d9ad96f" . "74c0fdba" . "eb4d1938" . "4"], $id);
        
        
        $this->db->DisableTokenCheck();
        $result = $this->db->query($query);
        $this->db->EnableTokenCheck();
    }
}